Bug 1251925 - .trashcan is listed as container and breaks object expiration in gluster-swift
.trashcan is listed as container and breaks object expiration in gluster-swift
Status: CLOSED ERRATA
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: gluster-swift (Show other bugs)
3.1
x86_64 Linux
medium Severity high
: ---
: RHGS 3.1.1
Assigned To: Prashanth Pai
SATHEESARAN
: ZStream
Depends On:
Blocks: 1251815
  Show dependency treegraph
 
Reported: 2015-08-10 06:13 EDT by Prashanth Pai
Modified: 2015-10-05 03:22 EDT (History)
7 users (show)

See Also:
Fixed In Version: swiftonfile-1.13.1-3
Doc Type: Bug Fix
Doc Text:
Previously, .trashcan directory which is always present in the root of the volume was considered to be a container and was returned in the container listing. With this fix, .trashcan directory is no longer returned in the container listing.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-10-05 03:22:58 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Prashanth Pai 2015-08-10 06:13:28 EDT
Description of problem:
Since RHS 3.1, ".trashcan" directory is visible from FUSE mount to a client. As this is first level directory in the glusterfs volume, it also shows up as a container when a GET operation is performed on the account (the volume) over Swift.


Version-Release number of selected component (if applicable):
-------------------------------------------------------------
RHS 3.1
swiftonfile-1.13.1-2

How reproducible:
-----------------
Perform a GET request on the account using curl.

Breakage of object expiration functionality:
--------------------------------------------
The special volume "gsexpiring" should contain directories whose names are timestamp - a number. The object expirer daemon code breaks because of following code being executed:

    int(".trashcan")

This part of code cannot be modified as it's part of Swift RPMs.

Actual results:
.trashcan directory visible as a container.
Also object expirer daemon raises exception.

Expected results:
.trashcan directory should not be visible as a container.
Object expirer daemon should not raise an exception.

Additional info:
Comment 3 Prashanth Pai 2015-08-18 03:02:45 EDT
Upstream fix: https://review.openstack.org/211869
Comment 4 Prashanth Pai 2015-08-19 01:40:36 EDT
Patch merged upstream.
Comment 5 SATHEESARAN 2015-09-01 13:01:27 EDT
Tested with swiftonfile-1.13.1-4.el7rhgs.noarch

GET request on the container no longer gets .trashcan

Marking this bug as verified
Comment 6 Divya 2015-09-28 04:28:46 EDT
Prashanth,

Please review and sign-off the edited doc text.
Comment 7 Prashanth Pai 2015-09-28 05:12:42 EDT
Doc text with some corrections:

"Previously, .trashcan directory which is always present in the root of the volume was considered to be a container and was returned in container listing. With this fix, .trashcan directory is no longer returned in container listing."
Comment 8 Divya 2015-09-28 05:23:53 EDT
Updated the doc text with minor edits.
Comment 9 Prashanth Pai 2015-09-28 05:33:03 EDT
Thanks Divya. Looks good to me.
Comment 11 errata-xmlrpc 2015-10-05 03:22:58 EDT
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2015-1845.html

Note You need to log in before you can comment on or make changes to this bug.